#include <iostream>
#include <vector>

#define f first
#define s second

using namespace std;

vector< vector<int> > g;
vector<bool> used0;
vector<bool> used1;
vector<int> used3;
vector< vector<int> > dp;
vector<int> have;
pair<int, int> nxt;

int t = 1;
void dfs0(int v) {
    used0[v] = 1;
    for (auto x : g[v]) {
        if(used0[x])
            continue;
        dfs0(x);
    }
}

int dfs1(int v, int p = -1) {
    used1[v] = 1;
    for (auto x : g[v]) {
        if(x == p)
            continue;
        if(used1[x]) {
            nxt.f = v;
            return x;
        }
        int r = dfs1(x, v);
        if(r == v) {
            nxt.s = x;
        }
        if(r != -1) {
            return r;
        }
    }
    return -1;
}

void dfs2(int v) {
    dp[v][0] = 0;
    dp[v][1] = 1;
    used3[v] = t;
    for (auto x : g[v]) {
        if(used3[x] == t)
            continue;
        dfs2(x);
        dp[v][0] += max(dp[x][0], dp[x][1]);
        dp[v][1] += dp[x][0];
    }
    return;
}

void dfs3(int v) {

    used3[v] = t;
    dp[v][0] = 0;
    dp[v][1] = 1;
    for (auto x : g[v]) {
        if(used3[x] == t)
            continue;
        dfs3(x);
        dp[v][0] += max(dp[x][0], dp[x][1]);
        dp[v][1] += dp[x][0];
    }
    if(nxt.f == v || nxt.s == v)
        dp[v][1] = dp[v][0];
    return;
}


int main() {

    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    g = vector <vector<int>> (n);
    dp = vector <vector<int>> (n + 1, vector<int> (2, 0));
    used0.assign(n, 0);
    used1.assign(n, 0);
    used3.assign(n, 0);
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        if(a == -1)
            continue;
        a--;
        g[a].push_back(i);
        g[i].push_back(a);
    }
    int flow = 0;
    for (int i = 0; i < n; i++) {
        if(used0[i])
            continue;
        dfs0(i);
        int ans = dfs1(i);
        if(ans == -1) {
            t++;
            dfs2(i);
            flow += max(dp[i][0], dp[i][1]);
        }
        else {
            t++;
            dfs2(ans);
            int maxx1 = dp[ans][0];
            t++;
            dfs3(ans);
            maxx1 = max(maxx1, dp[ans][1]);
            flow += maxx1;
        }
    }
    cout << flow << endl;
}
