#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#define f first
#define s second

using namespace std;

vector<vector<int>> a;
vector<vector<int>> par;
map<vector<int>, vector<int>> have;
vector<int> rasm;
int inf = 1e9 + 100;

bool check(int n, int k) {
    for (int i = 0; i < k; i++){
        int l = -inf, r = inf;
        for (int j = 0; j < n / 2; j++) {
            int l1 = min(a[par[j][0]][i], a[par[j][1]][i]);
            int r1 = max(a[par[j][0]][i], a[par[j][1]][i]);
            l = max(l1, l);
            r = min(r, r1);
        }
        if(l > r)
            return false;
    }
    return true;
}

bool find_ans1(int v, int n, int k) {

    if(v == n) {
        return check(n, k);
    }

    for (int i = 0; i < n / 2; i++) {
        if(par[i].size() == 2)
            continue;
        par[i].push_back(v);
        if(find_ans1(v + 1, n, k))
            return true;
        par[i].pop_back();
    }
    return false;
}

bool find_ans(int n, int k, int i) {

    if(i == k) {
        if(have[rasm].size() == 0)
            return true;

        vector<int> obr;
        for (int j = 0; j < k; j++) {
            obr.push_back(1 - rasm[j]);
        }
        if(have[obr].size() != have[rasm].size())
            return false;
        while(have[rasm].size() > 0) {
            par.push_back({have[obr].back(), have[rasm].back()});
            have[rasm].pop_back();
            have[obr].pop_back();
        }
        return true;
    }
    for (int j = 0; j < 2; j++) {
        rasm.push_back(j);
        if(!find_ans(n, k, i + 1))
            return false;
        rasm.pop_back();
    }
    return true;
}

int main() {

    ios_base::sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    a = vector<vector<int>> (n, vector<int> (k, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }

    if(n <= 10) {
        par = vector<vector<int>> (n / 2);
        bool ans = find_ans1(0, n, k);
        if(!ans) {
            cout << "NO";
            return 0;
        }
        cout << "YES" << endl;
        for(int i = 0; i < n / 2; i++) {
            cout << par[i][0] + 1 << " " << par[i][1] + 1 << endl;
        }

    }

    vector<vector<int>> g(n);
    for (int i = 0; i < k; i++) {
        vector<pair<int, int>> for_sort;
        for (int j = 0; j < n; j++) {
            for_sort.push_back({a[j][i], j});
        }
        sort(for_sort.begin(), for_sort.end());
        for (int j = 0; j < n / 2; j++) {
            g[for_sort[j].s].push_back(0);
        }
        for (int j = n / 2; j < n; j++) {
            g[for_sort[j].s].push_back(1);
        }
    }
    for (int i = 0; i < n; i++) {
        have[g[i]].push_back(i);
    }
    bool ans = find_ans(n, k, 0);
    if(!ans) {
        cout << "NO";
        return 0;
    }
    cout << "YES" << endl;
    for(int i = 0; i < n / 2; i++) {
        cout << par[i][0] + 1 << " " << par[i][1] + 1 << endl;
    }


}
