#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#define f first
#define s second

using namespace std;

vector<vector<int>> a;
vector<vector<int>> par;

int inf = 1e9 + 100;

bool check(int n, int k) {
    for (int i = 0; i < k; i++){
        int l = -inf, r = inf;
        for (int j = 0; j < n / 2; j++) {
            int l1 = min(a[par[j][0]][i], a[par[j][1]][i]);
            int r1 = max(a[par[j][0]][i], a[par[j][1]][i]);
            l = max(l1, l);
            r = min(r, r1);
        }
        if(l > r)
            return false;
    }
    return true;
}

bool find_ans(int v, int n, int k) {

    if(v == n) {
        return check(n, k);
    }

    for (int i = 0; i < n / 2; i++) {
        if(par[i].size() == 2)
            continue;
        par[i].push_back(v);
        if(find_ans(v + 1, n, k))
            return true;
        par[i].pop_back();
    }
    return false;
}



int main() {
    ios_base::sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    if(k == 1) {
        vector<pair<int, int>> for_sort;
        for (int i = 0; i < n; i++) {
            int a;
            cin >> a;
            for_sort.push_back({a, i});
        }
        sort(for_sort.begin(), for_sort.end());
        vector<pair<int, int>> ans;
        int l = 0, r = n - 1;
        for (int i = 0; i < n / 2; i++) {
            ans.push_back({for_sort[l].s, for_sort[r].s});
            l++, r--;
        }
        cout << "YES" << endl;
        for (auto x : ans) {
            cout << x.f + 1 << " " << x.s + 1 << endl;
        }
        return 0;
    }

    if(k == 2) {
        a = vector<vector<int>> (n, vector<int> (2, 0));
        par = vector<vector<int>> (n / 2, vector<int> (2, 0));
        vector<pair<int, int>> for_sort;
        vector<int> g1;
        vector<int> g2;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 2; j++) {
                cin >> a[i][j];
            }
            for_sort.push_back({a[i][0], i});
        }
        sort(for_sort.begin(), for_sort.end());
        for (int i = 0; i < n / 2; i++) {
            g1.push_back(for_sort[i].s);
        }
        for (int i = n / 2; i < n; i++) {
            g2.push_back(for_sort[i].s);
        }
        for_sort.clear();
        for(int i = 0; i < g1.size(); i++) {
            for_sort.push_back({a[g1[i]][1], g1[i]});
        }
        sort(for_sort.begin(), for_sort.end());
        g1.clear();
        for (int i = 0; i < for_sort.size(); i++) {
            g1.push_back(for_sort[i].s);
        }
        for_sort.clear();
        for(int i = 0; i < g2.size(); i++) {
            for_sort.push_back({a[g2[i]][1], g2[i]});
        }
        sort(for_sort.begin(), for_sort.end());
        g2.clear();
        for (int i = 0; i < for_sort.size(); i++) {
            g2.push_back(for_sort[i].s);
        }
        for (int i = 0; i < n / 2; i++) {
            par[i][0] = g1[i];
            par[i][1] = g2[n / 2 - 1 - i];
        }
        if(!check(n, k)) {
            cout << "NO";
            return 0;
        }
        cout << "YES" << endl;
        for(int i = 0; i < n / 2; i++) {
            cout << par[i][0] + 1 << " " << par[i][1] + 1 << endl;
        }
        return 0;
    }


    par= vector<vector<int>> (n / 2);
    a = vector<vector<int>> (n, vector<int> (k, 0));

    map<int, bool> have;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
            have[a[i][j]] = 1;
        }
    }
    bool ans = find_ans(0, n, k);
    if(!ans) {
        cout << "NO";
        return 0;
    }
    cout << "YES" << endl;
    for(int i = 0; i < n / 2; i++) {
        cout << par[i][0] + 1 << " " << par[i][1] + 1 << endl;
    }
}
